#include "proto.h"
#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <stddef.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>
#include <unistd.h>
#ifdef USE_ESD
#include <esd.h>
#define USE_DAEMON 1
#endif
#ifdef USE_ARTS
#include <artsc.h>
#ifndef USE_DAEMON
#define USE_DAEMON 1
#endif
#else
typedef int arts_stream_t;
#endif
#include <sys/time.h>

 
#include "file.h"

// wstawka
#include <sys/ioctl.h>
#include <sys/soundcard.h>
// koniec wstawki

#define SAMP_RATE 8000
long samp_rate = SAMP_RATE;

static int waveflags;
#define WAFEL_RAW 1
#define WAFEL_MP3 2
#define WAFEL_STDOUT 4
#define WAFEL_8244 8

static int mp1[]={1,3,5,7,9,11,2,4,6,8,10};
static int mp2[]={0,4,8,1,5,9,2,6,10,3,7};
struct SimpleWave {
	char riff[4];
	long tlength;
	char wave[4];
	char fmt_[4];
	long alwx10;
	short alwx01;
	short channels;
	long rate;
	long bytespersec;
	short bytespersample;
	short bitspersample;
	char _data[4];
	long datalength;
};

static struct SimpleWave wave_pat = {
	"RIFF",0,"WAVE","fmt ",16,1,1,8000,16000,2,16,"data",0};
	
static int wave_wrote;
static FILE *wave_file;

int dodebu=0;extern int low_end;

#define LAMEPATH "/usr/bin/lame"
int init_wave(int rate,char *name)
{
	struct SimpleWave wh;
	if (waveflags & WAFEL_MP3) {
		char bufor[256];
		sprintf(bufor,"%s -b 32 -r --resample 22.05 --bitwidth 16 -m m -s 44.1 -x - %s",LAMEPATH,name);
		wave_file=popen(bufor,"w");
		if (!wave_file) return 0;
		wave_wrote=1;
		return 1;
	}
	memcpy(&wh,&wave_pat,sizeof(wh));
	wh.rate=rate;
	wh.bytespersec=2*rate;
	if (waveflags & WAFEL_STDOUT) {
		wave_file=stdout;
		wh.tlength=0x7fffffff;
		wh.datalength=0x7fffffff;
	}
	else {
		wave_file=fopen(name,"wb");
		if (!wave_file) return 0;
	}
	if (!(waveflags & WAFEL_RAW)) fwrite(&wh,sizeof(wh),1,wave_file);
	wave_wrote=0;
	return 1;
}

#define SESD_SIZE (11*512)

static int www_last;

void write_wave_words(short *words,int ile)
{
	static short *wbuf=0;int wpos;
	if (!(waveflags & WAFEL_8244)) {
		fwrite(words,2*ile,1,wave_file);
		wave_wrote+=2*ile;
		return;
	}
	ile &= 0x7ffffffe;
	wave_wrote+=11*ile;
	if (!wbuf) wbuf=malloc(2*SESD_SIZE);
	if (!wbuf) exit(0);
	wpos=0;
	while (ile>0) {
		int p;
		if (wpos>=SESD_SIZE) {
			fwrite(wbuf,2*SESD_SIZE,1,wave_file);
			wpos=0;
		}
		p=wpos%11;
		wbuf[wpos]=(www_last*(11-mp1[p])+(*words)*mp1[p])/11;
		if (p==5 || p==10) {
			www_last=*words;
			words++;
			ile--;
		}
		wpos++;
	}
	if (wpos) {
		fwrite(wbuf,2*wpos,1,wave_file);
	}
}


void close_wave(void)
{
	int len;
	if (waveflags & WAFEL_STDOUT) return;
	if (waveflags & WAFEL_MP3) {
		pclose(wave_file);
		return;
	}
	if (!(waveflags & WAFEL_RAW)) {
		fseek(wave_file,4,SEEK_SET);
		len=sizeof(struct SimpleWave)-8+wave_wrote;
		fwrite(&len,4,1,wave_file);
		len=wave_wrote;
		fseek(wave_file,sizeof(struct SimpleWave)-4,SEEK_SET);
		fwrite(&len,4,1,wave_file);
	}
	fclose(wave_file);
}

file_write_p file_write = NULL;
file_term_p  file_term  = NULL;

int linear_fd = -1;
arts_stream_t arts_stream=0;

void aufile_write PROTO((int n,short *data));

void write_esd(int,short *);
void start_esd();

void
aufile_write(int n, short *data)
{
    if (linear_fd<0) return;
    write_wave_words(data,n);
}

void aufile_term PROTO((void));

void
aufile_term()
{
 /* Finish linear file */
   if (linear_fd >= 0) close_wave();
   linear_fd = -1;
}

int rate_set=0;

/* procedury ustawiania parametrw */

int arts_started;

void powiedz_start(char *name,int wavemode)
{
	if (!name) {
		start_esd();
		return;
	}
	waveflags=0;
	if (!strcmp(name,"-")) waveflags |= WAFEL_STDOUT;
	if (wavemode == 1) { /* raw output */
		waveflags |= WAFEL_RAW;
	}
	if (wavemode == 2) {
		waveflags |= WAFEL_MP3 | WAFEL_8244;
	}
	init_wave(samp_rate,name);
	linear_fd=1;
}


int esd_fd=-1;
int esd_mpx=0;
int esd_rate;
int esd_last,esd_phase;
extern int esd_wrote,esd_sps,esd_settv;extern struct timeval tv1;
extern int nouse_esd,use_arts;

// wstawka
extern char *audio_dsp;
extern int eightbit_dsp;
static int
audio_open(int samp_rate,int disp)
{
 int i;
 esd_fd = open(audio_dsp, O_WRONLY | O_NDELAY);
 if (esd_fd < 0)
  {
   if (disp) perror(audio_dsp);
   return 0;
  }
  ioctl(esd_fd, SNDCTL_DSP_SPEED, &samp_rate);
  i=0;
  ioctl(esd_fd,SNDCTL_DSP_STEREO,&i);
  i=(eightbit_dsp | low_end)?AFMT_U8:AFMT_S16_LE;
  ioctl(esd_fd,SNDCTL_DSP_SETFMT,&i);
  ioctl(esd_fd,SNDCTL_DSP_GETBLKSIZE,&i);
  if (dodebu) {
	  ioctl(esd_fd,SOUND_PCM_READ_RATE,&i);
	  fprintf(stderr,"Rate: %d\n",i);
	  ioctl(esd_fd,SOUND_PCM_READ_BITS,&i);
	  fprintf(stderr,"Bits: %d\n",i);
	  ioctl(esd_fd,SOUND_PCM_READ_CHANNELS,&i);
	  fprintf(stderr,"Channels: %d\n",i);
  }
 return 1;
}
// koniec wstawki


void powiedz_end()
{
	if (linear_fd>=0) aufile_term();linear_fd=-1;
	if (esd_fd>=0) {
#ifdef USE_ESD
		if (nouse_esd) close(esd_fd); else esd_close(esd_fd);
#else
		close(esd_fd);
#endif
		esd_fd=-1;
	}
#ifdef USE_ARTS
	if (arts_stream) {
		if (dodebu) fprintf(stderr,"Closing arts\n");
		arts_close_stream(arts_stream);
		arts_free();
		arts_stream=0;
		arts_started=0;
		if (dodebu) fprintf(stderr,"arts closed\n");
	}
#endif
}

void powiedz_pause()
{
	if (linear_fd>=0) aufile_term();linear_fd=-1;
	if (esd_fd>=0) {
#ifdef USE_ESD
		if (nouse_esd) close(esd_fd); else esd_close(esd_fd);
#else
		close(esd_fd);
#endif
		esd_fd=-1;
	}
#ifdef USE_ARTS
	if (arts_stream) {
		if (dodebu) fprintf(stderr,"Closing arts\n");
		arts_close_stream(arts_stream);
		arts_stream=0;
		if (dodebu) fprintf(stderr,"arts closed\n");
	}
#endif
}



void start_esd()
{
	int i;
	if (esd_fd>=0 || arts_stream) return;
	esd_rate=powiedz_get_rate();
#ifdef USE_DAEMON
	if (nouse_esd) {
#endif
		if (!audio_open(low_end?22050:esd_rate,1)) exit(0);
		if (dodebu) fprintf(stderr,"Output: %s\n",audio_dsp);
		esd_mpx=0;
		return;
#ifdef USE_DAEMON
	}
#ifdef USE_ARTS
#ifndef USE_ESD
	if (use_arts) goto usbrt;
	if (audio_open(esd_rate,0)) {
		if (dodebu) fprintf(stderr,"Output: %s %d\n",audio_dsp,esd_rate);
		nouse_esd=1;
		esd_mpx=0;
		return;
	}
usbrt:
#endif
#endif	
	if ((esd_rate=powiedz_get_rate())==16000) {
		esd_rate=44100;
		esd_mpx=2;
		esd_last=0;
		esd_phase=0;
	} else if ((esd_rate=powiedz_get_rate())==8000) {
		esd_rate=44100;
		esd_mpx=1;
		esd_last=0;
		esd_phase=0;
	} else {
		esd_mpx=0;
	}
	esd_sps=esd_rate;
	esd_wrote=0;
//	printf("Starting ESD rate %d\n",esd_rate);
#ifdef USE_ESD
#ifdef USE_ARTS
	if (use_arts) goto usart;
#endif
	if (dodebu) fprintf(stderr,"Trying esd\n");
	esd_fd=esd_play_stream_fallback(
			ESD_BITS16 | ESD_MONO | ESD_STREAM | ESD_PLAY,
			esd_rate,
			NULL,NULL);
//	printf("ESD rate %d\n",esd_rate);
	if (esd_fd>=0) {
		if (dodebu) fprintf(stderr,"Output: esd\n");
		return;
	}
	if (dodebu) fprintf(stderr,"esd failed\n");
#endif
#ifdef USE_ARTS
	use_arts=1;
usart:	if (!arts_started) {
		i=arts_init();
		if (i) {
			fprintf(stderr,"ARTS: %s\n",arts_error_text(i));
			exit(1);
		}
		arts_started=1;
	}
	arts_stream=arts_play_stream(esd_rate, 16, 1, "powiedz");
	if (dodebu) fprintf(stderr,"Output: arts\n");
	if (!arts_stream) exit(1);
#else
	exit(1);
#endif
#endif
}


/*
10 20

0 4 8 1 5 9 2 6 10 3 7
    x     x      x   x
*/		

write_audio_fd(unsigned char *covr,int n)
{
	int i,zet;
	for (;n>0;) {
		i=write(esd_fd,covr,n);
		if (i<0) return;
	//	printf("%d of %d\n",i,n);
		n-=i;
		covr+=i;
	}
}

#ifdef USE_DAEMON
_write_esd_data(void *data,int n)
{
	if (dodebu) fprintf(stderr,"writing %d\n",n);
#ifdef USE_ARTS
#ifdef USE_ESD
	if (use_arts)
#endif
	{
		int i=arts_write(arts_stream,data,n);
		if (i<0) {
			fprintf(stderr,"ARTS: %s\n",arts_error_text(i));
			exit(1);
		}
		return i;
		
	}
#endif
#ifdef USE_ESD
	return write(esd_fd,data,n);
#endif
}

write_esd_data(void *data,int n)
{
	char *d=data;
	while (n>0) {
		int i=_write_esd_data(d,n);
		if (i<0) break;
		d+=i;
		n-=i;
	}
}

#endif

void write_esd(int n,short *data)
{
	static short *esdbuf=0;int esdpos;
	static unsigned char covr[8192];
	int i;
	if (esd_fd<0 && !arts_stream) return;
	if (esd_settv) {
		gettimeofday(&tv1,0);esd_wrote=0;esd_settv=0;
	}
	if (low_end) {
		int m;static int doit[]={0,1,0,0,1,0,0,1,0,0,1};
		int mini=65535,maxi=-65535;
		for (i=0;i<n;i++) {
			if (data[i]<mini) mini=data[i];
			if (data[i]>maxi) maxi=data[i];
		}
/*

4/11

0 0 1 1 1 2 2 2 3 3 3

*/
		for (;n>0;) {
			
			for (i=0;i<8192 && n>0;m++,i++) {
				covr[i]=((*data-mini)*255)/(maxi-mini);
				
				if (doit[m%11]) {
					data++;
					n--;
				}
			}
			write_audio_fd(covr,i);
		}
		i=0;
	        ioctl(esd_fd, SNDCTL_DSP_SYNC, &i);
		return;
	}
#ifdef USE_DAEMON	
	if (nouse_esd)
#endif
		{
		
		if (eightbit_dsp) for (;n>0;) {
			for (i=0;i<n && i<8192;i++) covr[i]=(*data++ - 32768)/256;
			write_audio_fd(covr,i);
			n-=i;
		}
		else for (;n>0;) {
			i=n;if (i>4096) i=4096;
			write_audio_fd(data,2*i);
			data+=i;
			n-=i;
		}
		i=0;
	        ioctl(esd_fd, SNDCTL_DSP_SYNC, &i);
		return;
	}
#ifdef USE_DAEMON	
	if (!esd_mpx) {
		write_esd_data(data,2*n);
		esd_wrote+=n;
		return;
	}
	if (!esdbuf) esdbuf=malloc(2*SESD_SIZE);
	if (!esdbuf) exit(0);
	esdpos=0;
	n&=0x7ffffffe;
	if (esd_mpx==2)	while (n>0) {
		int p;
		if (esdpos>=SESD_SIZE) {
			write_esd_data(esdbuf,2*SESD_SIZE);
			esd_wrote+=SESD_SIZE;
			esdpos=0;
		}
		p=esdpos%11;
		esdbuf[esdpos]=(esd_last*(11-mp2[p])+(*data)*mp2[p])/11;
		if (p==2 || p==5 || p==8 || p==10) {
			esd_last=*data;
			data++;
			n--;
		}
		esdpos++;
	}
			
	else while (n>0) {
		int p;
		if (esdpos>=SESD_SIZE) {
			write_esd_data(esdbuf,2*SESD_SIZE);
			esd_wrote+=SESD_SIZE;
			esdpos=0;
		}
		p=esdpos%11;
		esdbuf[esdpos]=(esd_last*(11-mp1[p])+(*data)*mp1[p])/11;
		if (p==5 || p==10) {
			esd_last=*data;
			data++;
			n--;
		}
		esdpos++;
	}
	if (esdpos) {
		write_esd_data(esdbuf,2*esdpos);
		esd_wrote+=esdpos;
	}
#endif
}		

