#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "powiedz.h"

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/time.h>
#include <unistd.h>
#include <signal.h>
#include <fcntl.h>

#ifdef USE_ESD
#include <esd.h>
#define USE_DAEMON 1
#endif
#ifdef USE_ARTS
#include <artsc.h>
#ifndef USE_DAEMON
#define USE_DAEMON 1
#endif
#else
typedef int arts_stream_t;
#endif

char *outfname;
int wavemode;
int linear_mode;
int use_arts;
extern int dodebu;

int server_mode;
int server_queue;
char *tabname;

struct SayMessage {
    long type;
    long mode;
    char buffer[2000];
};

int EndMsgSystem(int queue)
{
    if (queue!=-1) return msgctl(queue,IPC_RMID,0);
}

xsay_sentence(char *s,int mode)
{
	struct SayMessage SM;
	if (!server_mode) {
		say_sentence(s,mode);
		return;
	}
	if (strlen(s)>1999) return;
	strcpy(SM.buffer,s);
	SM.type=1;
	SM.mode=mode;
	if (dodebu) fprintf(stderr,"Client: sending %s to %d\n",s,server_queue);
	if (msgsnd(server_queue,(void *)&SM,sizeof(SM)-sizeof(long),0)<0) {
		perror("Not sent ");
		exit(0);
	}
}
	
powiedz_string(char *s)
{
	char *c;int mode;
	if (!server_mode && !linear_mode) powiedz_start(outfname,wavemode);
	for (;;) {
        	while (*s && isspace(*s)) s++;
		if (!*s) break;
        	for (c=s;*c;c++) {
        		if ((*c=='.' || *c==',' || *c==':') && (!c[1] || isspace(c[1]))) break;
        		if (strchr("!?;\"()",*c)) break;
        	}
        	if (!*c) mode=0;
        	else {
			switch (*c) {
            			case '?':mode=1;break;
            			case '.':
            			case '!':mode=0;break;
            			case ';':mode=3;break;
            			default:mode=2;break;
            		}
        		*c++=0;
		}
        	if (*s) {
			xsay_sentence(s,mode);
		}
        s=c;
        }
	if (!server_mode && !linear_mode) powiedz_end();
}

char inbuf[65536];
int inpos;
powiedz_bufor()
{
	int mode;
	if (inpos<2) return;
	inbuf[inpos]=0;
	switch (inbuf[inpos-1]) {
            	case '?':mode=1;break;
            	case '.':
            	case '!':mode=0;break;
            	case ';':mode=3;break;
            	default:mode=2;break;
            	}
	inbuf[inpos]=0;
	xsay_sentence(inbuf,mode);
	inpos=0;
}

tabwrite(int n)
{
	int fd;
	if (!tabname) return;
	fd=open(tabname,O_RDWR);
	if (fd<0) return;
	write(fd,&n,4);
	close(fd);
}

powiedz_plik(char *nazwa)
{
	FILE *f;char *c;int znak,lznak;
	if (nazwa) {
		f=fopen(nazwa,"r");
		if (!f) return 0;
		if (tabname) {
			int fd,le;
			fd=open(tabname,O_RDWR);
			if (fd>=0) {
				read(fd,&le,4);
				close(fd);
				if (le>0) fseek(f,le,SEEK_SET);
			}
			else {
				le=0;
				fd=open(tabname,O_WRONLY | O_CREAT, 0644);
				if (fd>0) {
					write(fd,&le,4);
					close(fd);
				}
			}
		}
				
	}
	else f=stdin;
	inpos=0;
	if (!server_mode) powiedz_start(outfname,wavemode);
	tabwrite(0);
	if (linear_mode) {
		char linebuf[1024];
		while (fgets(linebuf,1024,f)) {
			powiedz_string(linebuf);
		}
		powiedz_end();
		return;
	}
			
	znak=' ';
	for (;;) {
		lznak=znak;
		znak=fgetc(f);
		if (znak==EOF) {
			inbuf[inpos++]='.';
			powiedz_bufor();
			tabwrite(-1);
			break;
		}
		if (strchr(".,:",znak)) {
			int znak1;
			lznak=znak;
			znak1=fgetc(f);
			if (znak1==EOF || isspace(znak1)) {
				inbuf[inpos++]=znak;
				powiedz_bufor();
				if (znak=='.') tabwrite(ftell(f));
				continue;
			}
			inbuf[inpos++]=znak;
			inbuf[inpos++]=znak1;
			continue;
		}
        	if (strchr("!?;\"()",znak) || (isspace(lznak) && znak=='-')) {
			inbuf[inpos++]=znak;
			powiedz_bufor();
			if (strchr("!?",znak)) tabwrite(ftell(f));
			continue;
		}
		inbuf[inpos++]=znak;
	}
	if (!server_mode && !linear_mode) powiedz_end();
	if (nazwa) fclose(f);
}
int tx(int a,int b,int c)
{
	if (a<b) return b;
	if (a>c) return c;
	return a;
}
		
#ifdef MBROLA_BIN
int philosophy;
#endif
int StartMsgSystem(int queue)
{
    return msgget((queue==-1)?IPC_PRIVATE:queue,0666|IPC_CREAT);
}

void strap(int dummy)
{
	exit(0);
}
int xpid;
void ate(void)
{
	if (xpid==getpid())EndMsgSystem(server_queue);
}
int esd_wrote,esd_sps,esd_settv;
struct timeval tv1,tv2;
extern arts_stream_t arts_stream;


start_server()
{
	struct SayMessage SM;
	server_queue=msgget(0x59EEC001,0);
	if (dodebu) fprintf(stderr,"Server queue=%d\n",server_queue);
	if (server_queue<0) {
		int pid;
		pid=fork();
		if (pid) {
			sleep(1);
			server_queue=msgget(0x59EEC001,0);
			if (server_queue<0) exit(0);
			return;
		}
		if (dodebu) fprintf(stderr,"Starting server\n");
		xpid=getpid();	
		server_queue=msgget(0x59EEC001,0666 | IPC_CREAT);
		if (server_queue<0) exit(0);
		signal(SIGTERM,strap);
		signal(SIGSTOP,strap);
		signal(SIGABRT,strap);
		signal(SIGINT,strap);
		atexit(ate);
		server_mode=2;
		for (;;) {
			div_t cajt;int seku,usek;int i;
			extern int esd_fd;
			if (dodebu) fprintf(stderr,"Waiting\n");
			i=msgrcv(server_queue,&SM,sizeof(SM)-4,0,IPC_NOWAIT);
			if (i<0) {
				if (dodebu) fprintf(stderr,"esd inactivation\n");
				powiedz_pause();
				if (dodebu) fprintf(stderr,"inactive, waiting for message on %d\n",server_queue);
				if (msgrcv(server_queue,&SM,sizeof(SM)-4,0,0)<0) exit(0);
				if (dodebu) fprintf(stderr,"Doczekalem sie\n");
			}
			if (dodebu) fprintf(stderr,"Message received\n");
			if (esd_fd<0 && !arts_stream) {
				if (dodebu) fprintf(stderr,"activation sound\n");
				powiedz_start(0,0);
				if (dodebu) fprintf(stderr,"active\n");
			}
			gettimeofday(&tv1,0);
			esd_wrote=0;esd_settv=1;
			say_sentence(SM.buffer,SM.mode);
			cajt=div(esd_wrote,esd_sps);
			seku=cajt.quot;
			usek=(cajt.rem *1000000.0)/esd_sps;
			gettimeofday(&tv2,0);
			tv2.tv_usec-=tv1.tv_usec;if (tv2.tv_usec<0) {
				tv2.tv_usec+=1000000;
				tv2.tv_sec--;
			}
			tv2.tv_sec-=tv1.tv_sec;
			//printf("time diff %d.%06d\n",tv2.tv_sec,tv2.tv_usec);
			//printf("time pred %d.%06d\n",seku,usek);
			usek-=tv2.tv_usec;if (usek<0) {usek+=1000000;seku--;}
			seku-=tv2.tv_sec;
			tv2.tv_usec=usek;tv2.tv_sec=seku;
			//printf("time span %d.%06d\n",tv2.tv_sec,tv2.tv_usec);
			/*
			tv2.tv_usec+=200000;if (tv2.tv_usec>=1000000) {
				tv2.tv_usec-=1000000;
				tv2.tv_sec++;
			}
			*/
					
			if (tv2.tv_sec>0 || (tv2.tv_sec==0 && tv2.tv_usec>0)) {
				//printf("Select start\n");
				select(0,0,0,0,&tv2);
				//printf("Select end\n");
			}
				
		}
	}
}	

int nouse_esd=0,low_end=0;
char *audio_dsp="/dev/dsp";
int eightbit_dsp=0;

main(int argc,char *argv[])
{
	int i,n,is_help;char *plik;
	init_powiedz();
	
	i=1;plik=0;is_help=0;
	for (;;) {
		char c;
		if (argc<=i) break;
		if (argv[i][0]!='-') break;
		if (!strcmp(argv[i],"--")) {
			i++;
			break;
		}
		c=argv[i][1];
		i++;
		switch(c) {
			case 'n': powiedz_set_robotic(1);break;
			case 'R': powiedz_set_roman(1);break;
			case 'r': if (i<argc) powiedz_set_rate(tx(atoi(argv[i++]),5000,22050));break;
			case 'F': if (i<argc) plik=argv[i++];break;
			case 'h': is_help=1;break;
			case 't': if (i<argc) powiedz_set_tempo(tx(15-atoi(argv[i++]),5,15));break;
			case 'f': if (i<argc) powiedz_set_freq(tx(atoi(argv[i++]),60,440));break;
			case 'w': wavemode = 0;if (i<argc) outfname=argv[i++];break;
			case 'p': wavemode = 1;if (i<argc) outfname=argv[i++];break;
			case 'm': wavemode = 2;if (i<argc) outfname=argv[i++];break;
#ifdef MBROLA_BIN
			case 'M': philosophy |=1;break;
#endif
			case 'T': if (i<argc) tabname=argv[i++];break;
			case 'S': server_mode=1;break;
			case 'l': linear_mode=1;break;
#ifdef USE_DAEMON
			case 'A': nouse_esd=1;audio_dsp="/dev/dsp";break;
#endif
			case 'a': nouse_esd=1;if (i<argc) audio_dsp=argv[i++];else audio_dsp="/dev/dsp";break;
			case '8': eightbit_dsp=1;break;
#ifdef USE_ARTS
			case 'k': nouse_esd=0;use_arts=1;break;
#endif
			case 'L': low_end=1;break;
			case 'v': dodebu=1;break;
		}
	}
	if (is_help) {
		fprintf(stderr,"Powiedz v1.0\nSposb uycia:\n%s [opcje] [tekst]\n\
Opcje:\n\
  -h - wyswietlenie tektu pomocy\n\
  -F <nazwa> - plik tekstowy do odczytu\n\
  -r <czstotliwo> - czstotliwo prbkowania (5000 - 22050, normalnie 8000)\n\
  -n - wyczenie melodii\n\
  -R - wczenie interpretacji cyfr rzymskich\n\
  -t <tempo> - tempo (0 - 10, normalnie 5)\n\
  -f <czstotliwo> - czstotliwo bazowa (60 - 440, normalnie 133)\n\
  -L - 8 bitw, synteza Klatta, 8kHz wewntrznie przetwarzane na 22050 Hz\n"
#ifdef USE_DAEMON
"     Wymusza uycie /dev/dsp jeli nie byo opcji -A lub -a\n"
#endif
"     (przeznaczone specjalnie do sterownika wewntrznego goniczka)\n\
  -w <nazwa> - plik wynikowy (wav)\n\
  -p <nazwa> - plik wynikowy (raw 16-bit mono)\n\
  -m <nazwa> - plik wynikowy (mp3 mono, 22050 Hz)\n"
#ifdef MBROLA_BIN
"  -M - uzycie syntezatora mbrola zamiast Klatta\n"
#endif
"  -T - nazwa pliku zakadki\n\
  -S - wczenie trybu serwer (pierwszy uruchomiony program staje sie serwerem)\n\
  -l - tryb czytania kadej linii z wejcia\n"
#ifdef USE_ARTS
"  -k - wymusza uzycie arts\n"
#endif
#ifdef USE_DAEMON
"  -A - wymuszenie uycia /dev/dsp\n"
#endif
"  -a <device> - wymuszenie uycia <device>\n\
  -8 - z opcj"
#ifdef USE_DAEMON
"   -A lub"
#endif
" -a wymusza zastosowanie 8-bitowego kodowania zamiast 16\n\
Uwagi:\n\
  generowanie pliku wyjsciowego wycza wyjcie audio\n\
  do generowania plikw mp3 wymagany jest /usr/bin/lame\n\
  jeli nie podany jest plik wejciowy, a w linii polece nie ma tekstu,\n\
    program czyta tekst ze standartowego wejcia\n\
  jeli wyjciem programu jest plik mp3, automatycznie ustalana jest\n\
    czstotliwo prbkowania 8000 Hz\n"
#ifdef USE_DAEMON
"  jeli wyjciem programu jest demon "
#ifdef USE_ESD
"esd "
#ifdef USE_ARTS
"lub "
#endif
#endif
#ifdef USE_ARTS
"arts "
#endif
"a czstotliwo\n\
    prbkowania wynosi 8000Hz, nastpuje wewntrzna konwersja na 44.1 kHz\n"
#endif
,argv[0]);
#ifdef MBROLA_BIN
		printf("  Syntezator mbrola wymaga pliku wykonywalnego %s\n\
    oraz bazy danych %s. W przypadku jego uycia\n\
    parametry -n, -t, -f oraz -r nie s uwzgldniane.\n",MBROLA_BIN,MBROLA_DB);
#endif
		exit(0);
	}
	if (low_end) {
#ifdef USE_DAEMON
		nouse_esd=1;
#endif
#ifdef MBROLA_BIN
		philosophy=0;
#endif
		outfname=0;
		eightbit_dsp=0;
		powiedz_set_rate(8000);
	}
	if (server_mode) {
		if (outfname) {
			fprintf(stderr,"Konflikt opcji - w trybie serwer nie jest mozliwe ustawienie wyjscia do pliku\n");
			exit(1);
		}
		start_server();
	}
	//printf("Tab = %s\n",tabname);
	if (wavemode==2) powiedz_set_rate(8000);
#ifdef MBROLA_BIN
	if (philosophy & 1) powiedz_set_rate(16000);
		
#endif
	if (plik) {	
		powiedz_plik(plik);
		exit(0);
	}
	if (argc<=i) {
		powiedz_plik(0);
		exit(0);
	}
	for (n=0;i<argc;i++,n++) {
		if (n) {
			strcat(inbuf," ");
			strcat(inbuf,argv[i]);
		}
		else strcpy(inbuf,argv[i]);
	}
	//printf("PS %s\n",inbuf);
	powiedz_string(inbuf);
	exit(0);
}
		
