/* $Id: phtoelm.c,v 1.13 1994/11/08 13:30:50 a904209 Exp a904209 $
 */
char *phtoelm_id = "$Id: phtoelm.c,v 1.13 1994/11/08 13:30:50 a904209 Exp a904209 $";
#include <stdio.h>
#include <ctype.h>
#include <stdarg.h>
#include <sys/types.h>
#include <stddef.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>
#include <unistd.h>
#include "proto.h"
#include "elements.h"
#include "phfeat.h"
#include "phtoelm.h"
#include "holmes.h"
#include "nsynth.h"
#include "newstring.h"
#include "polphones.h"

struct phonem {
    char pho;
    char defs[9];
    } PhonemTable[]={
{'a', PHONE_AX},
{'b', PHONE_B ,PHONE_BY ,PHONE_BZ},
{'c', PHONE_CT ,PHONE_TV ,PHONE_TX},
{'', PHONE_CT ,PHONE_TQ ,PHONE_SV},
{'', PHONE_CH ,PHONE_TQ, PHONE_CI},
{'d', PHONE_D ,PHONE_DY ,PHONE_DZ},
{'D', PHONE_CT ,PHONE_DX ,PHONE_DQ},
{'J', PHONE_J ,PHONE_JY ,PHONE_QQ ,PHONE_JY},
// {'G', PHONE_DT , PHONE_DJ},
{'G', PHONE_DT ,PHONE_QQ, PHONE_DJ},
{'e', PHONE_EX},
{'f', PHONE_F},
{'g', PHONE_G ,PHONE_GY ,PHONE_GZ},
{'h', PHONE_H},
{'i', PHONE_II},
{'j', PHONE_Y},
{'k', PHONE_K ,PHONE_KY ,PHONE_KZ},
{'l', PHONE_L},
{'w', PHONE_W},
{'m', PHONE_M},
{'n', PHONE_N},
{'N', PHONE_N},
{'', PHONE_NI},
{'o', PHONE_OX},
{'p', PHONE_P ,PHONE_PY ,PHONE_PZ},
{'r', PHONE_RQ ,PHONE_RV ,PHONE_RQ  ,PHONE_RV ,PHONE_RQ },
//{'r', PHONE_RV ,PHONE_RQ ,PHONE_RV ,PHONE_RQ ,PHONE_RV ,PHONE_RQ ,PHONE_RV},
{'s', PHONE_S},
{'', PHONE_SI},
{'', PHONE_SQ},
{'t', PHONE_T ,PHONE_TY ,PHONE_TZ},
{'u', PHONE_UX},
{'v', PHONE_V},
{'y', PHONE_YX},
{'z', PHONE_Z ,PHONE_QQ ,PHONE_ZZ},
{'', PHONE_ZQ},// 
{'', PHONE_ZI},//
{' ', PHONE_Q},
{'q', PHONE_END},
{'=', PHONE_IX},
{'#', PHONE_I1},
{0}};


Elm_ptr FindElement PROTO((int c));



#define StressDur(e,s) ((e->du)*speed+(s?4:0))
extern int robotic;

unsigned phone_to_elm(phone,n,elm,dbg,den)
char *phone;
int n;
int *dbg;
int *den;
newstring_ptr elm;
{
    int mask=0;
    int pos=0;
    int pbs=0;
    int stress = 0;
    char *s = phone;
    unsigned t = 0;
    char *limit = s + n;
    Elm_ptr pelm;
    char *c;
    int i;
    static char *xstress="+-,\'";
    while (s<limit && *s) {

// zaatwiamy granice dla intonacji

	if (!(mask & 1) && pos==*dbg) {
	    *dbg=pbs;
	    mask|=1;
	}
	if (!(mask & 2) && pos==*den) {
	    *den=pbs;
	    mask|=2;
	}
   	pos++;
//  	fprintf(stderr,"Fonem %c\n",*s);
   	for (i=0;PhonemTable[i].pho;i++) if (PhonemTable[i].pho==*s) break;
   	if (!PhonemTable[i].pho) goto no_phonem;
  	c=PhonemTable[i].defs;
  	while (*c) {
// 	    fprintf(stderr,"Alofon %d\n",*c); 	
   	    pelm=FindElement(*c);
   	    if (pelm) {
   		c++;
		ns_append(elm, pelm-Elements);
		pbs+=3;
 		if (!(pelm->feat & vwl)) stress = 0;
		t += ns_append(elm,StressDur(pelm,stress));
		ns_append(elm, robotic?0:stress);
		stress=0;
        	continue;
            	}
 //           fprintf(stderr,"Bd wewntrzny: niezdefiniowany alofon %d dla fonemu %s\n",*c++,*s);
            }
        s++;
        continue;
no_phonem:
        if (c=strchr(xstress,*s)) {
            if (*s=='+') stress=-1;
            else stress=c-xstress;
            s++;
            continue;
            }
//        fprintf(stderr,"Ignoruj %c w %s\n",*s++,phone);
        }
    return t;
}

