#include <stdio.h>
#include <ctype.h>
#include <sys/types.h>
#include <stddef.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>
#include <unistd.h>
#include <math.h>
#ifdef USE_ESD
#include <esd.h>
#define USE_DAEMON 1
#endif
#ifdef USE_ARTS
#include <artsc.h>
#ifndef USE_DAEMON
#define USE_DAEMON 1
#endif
#else
typedef int arts_stream_t;
#endif
#include "proto.h"
#include "nsynth.h"
#include "newstring.h"
#include "holmes.h"
#include "phtoelm.h"
#include "file.h"
#include "say.h"
#include "powiedz.h"

#ifdef MBROLA_BIN
extern int philosophy;
extern void umbrella(int,char *);
extern void say_mbrola(void);
#endif

char *program = "powiedz";
int robotic;
extern int linear_fd,esd_fd;

static int verbose = 0;


static unsigned append_phones PROTO((char *phones,newstring_ptr phone,int mode,int *dbg,int *den));

static unsigned append_phones(phones,phone,mode,dbg,den)
char *phones;newstring_ptr phone;int mode;int *dbg;int *den;
{
    unsigned nph=0;int i1,actyp,lact;
    char *c,*d,*zpr,*zos;
    *dbg=i1=0;
    *den=0;
    
    /* melodia zdania. Akcenty s ju prowizorycznie zaznaczone */
    
    for (c=phones,zpr=zos=0;*c;c++) if (*c=='\'') {
	    zpr=zos;
	    zos=c;
	   
    }
    
    /* zpr - przedostatnia akcentowana; zos - ostatnia akcentowana */
    lact=1;
    if (zos) for (c=zos+2;*c;c++) if (strchr("aeiouy",*c)) {
	    lact=0; /* akcent nie na ostatniej sylabie */
	    break;
    }
    
    if (mode==1) { /* pytanie */
	    if (zos) {
		    if (!lact) *zos='+'; /* opadajca jeli nie ostatnia */
		    else if (zpr) *zpr='+'; /* opadajca przedostatnia akcentowana */
	    }
    }
    else if (mode==2) {
	    if (zos) *zos='+';
    }
    else if (!mode) {
	    if (zos && lact) *zos='+';
    }
    for (c=phones,d=0;*c;c++) if (*c=='\'') {
	    *c++;
	    break;
    }
    actyp=0;
    for (;*c;c++) if (*c=='\'') {
	    d=c;
	    *c="+,"[actyp];
	    actyp^=1;
    }
    if (d) *d='\'';
    
#ifdef MBROLA_BIN
    if (philosophy & 1) {
	    umbrella(mode,phones);
	    return 1;
    }
#endif
    
    while (*phones) {
        if (strchr("aeiuoy",*phones)) {*dbg=i1;i1=nph;}
        ns_append(phone,*phones++);
        nph++;
        }
    *den=nph;
    if (*dbg>5) (*dbg)--;
    if (mode!=2) {
        ns_append(phone,' ');
        ns_append(phone,' ');
        nph+=2;
        }
    ns_append(phone,' ');
    ns_append(phone,' ');
    return nph+2;
}

extern arts_stream_t arts_stream;

void
say_phones(phone, len, verbose,mode,dbg,den)
char *phone;
int len;
int verbose;
int mode;
int dbg;
int den;
{
 static newstring_t elm={0,0,0};
 unsigned frames;
 ns_init(&elm);
 
 if ((frames = phone_to_elm(phone, len, &elm,&dbg,&den)))
  {
   unsigned max_samples = frames * klatt_global.nspfr;
   short *samp = (short *) malloc(sizeof(short) * max_samples);
#if 0
   if (verbose)
    fprintf(stderr,"%.*s\n", len, phone);
#endif
   if (samp)
    {
     unsigned nsamp = holmes(elm.items, (unsigned char *) ns_value(&elm),
                             max_samples, samp,mode,dbg,den);
     if (linear_fd>=0)
      aufile_write(nsamp, samp);
     if (esd_fd>=0 || arts_stream) write_esd(nsamp,samp);
     free(samp);
    }
  }
}

extern char *trancode PROTO((char *s,int l));
void say_sentence(char *senten,int mode)
{
    
    static newstring_t phone={0,0,0};int dbg,den;
    
    senten=trancode(senten,strlen(senten));
    ns_init(&phone);
    append_phones(senten,&phone,mode,&dbg,&den);
#ifdef MBROLA_BIN
    if (philosophy & 1) {
	    say_mbrola();
	    return;
    }
#endif
    say_phones((char *)ns_value(&phone), phone.items,verbose,mode,dbg,den);
}

static char *allet="acelnosxz";
static char *bllet="󶼿";

extern char *Szorty[];
extern void say_string PROTO((char *s));

extern int do_roman;

int init_powiedz(void)
{
	begin_synth();
	powiedz_set_rate(8000);
	powiedz_set_robotic(0);
	powiedz_set_roman(0);
	powiedz_set_tempo(10);
	powiedz_set_freq(133);
}
	


	
/* parametry */

void powiedz_set_robotic(int i)
{
	robotic=i?1:0;
}
void powiedz_set_roman(int i)
{
	do_roman=i?1:0;
}
int powiedz_get_robotic(void)
{
	return robotic?1:0;
}
int powiedz_get_roman(void)
{
	return do_roman?1:0;
}

