#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "powiedz.h"

/*

    "aa","A'a","bb","cc","","=","","dd","D","J","G","G=",
    "ee","E'e","ff","gg","hh","Hh","ii","I'i","jj","J=","kk","ll",
    "mm","nn","","oo","O'o","pp","qQ","rr","ss","","","tt",
    "uu","U'u","vv","ww","yy","Y'y","zz","","",

MBROLA:
*/

struct mbrol {
	char fonem;
	char *sampa;
	int dur;
} mbrol[]={
{'a',"a",120},	
{'e',"e",120},	
{'i',"i",120},	
{'o',"o",120},	
{'u',"u",120},	
{'y',"I",120},	
{'Q',"_",20},
{' ',"_",20},
{'=',"j",30},
{'#',"j",30},
{'p',"p",30},
{'b',"b",100},
{'t',"t",70},
{'d',"d",50},
{'k',"k",70},
{'g',"g",90},
{'f',"f",100},
{'v',"v",50},
{'s',"s",150},
{'z',"z",90},
{'',"S",150},
{'',"Z",90},
{'',"s'",150},
{'',"z'",90},
{'h',"x",80},
{'c',"ts",120},
{'D',"dz",120},
{'',"tS",120},
{'J',"dZ",120},
{'',"ts'",100},
{'G',"dz'",100},
{'m',"m",120},
{'n',"n",80},
{'N',"N",70},
{'',"n'",70},
{'l',"l",90},
{'r',"r",70},
{'w',"w",70},
{'j',"j",60},
{0,0,0}};

#define mientki(c) strchr("G",(c))
#define UMBRELLA_PHO "/tmp/umbrella.pho"

extern int linear_fd,esd_fd;
void umbrella (int mode, char *phones)
{
	int i,stres;char *c,*osta,*przedo;
	int dur,mst,qua,ldur;
	FILE *f;
	double mp[4]={0.91,1.0,1.1,1.0};
	double mo[4]={0.83,1.3,1.2,1.0};
	
	if (!(f=fopen(UMBRELLA_PHO,"w"))) return;
	fprintf(f,"; BEGIN PARASOL TRANSLATOR\n");
	// fprintf(stderr,"%s\n",phones);
	fprintf(f,"_ 200 50 150\n");
	stres=0;
	mst=0;
	for (c=phones,osta=przedo=0;*c;c++) if (strchr("aeiouy",*c)) {
		przedo=osta;
		osta=c;
	}
	ldur=0;
	while (*phones) {
		if (strchr("+-,\'",*phones)) {
			stres=*phones++;
			continue;
		}
		for (i=0;mbrol[i].fonem;i++) if (mbrol[i].fonem==*phones) break;
		if (!mbrol[i].fonem) {
			phones++;
			stres=0;
			continue;
		}
		if (i<6) { /* samogoska */
			dur=mbrol[i].dur;
			mst=150;
			
			dur=220-ldur;if (dur<100) dur=100;
		//	printf("LX=%d\n",ldur+dur);
			ldur=0;
			if (stres) {
				dur+=80;
				if (stres=='+') mst=145;else
				if (stres=='\'') mst=160;else mst=155;
			}
			if (phones==osta) mst*=mo[mode];
			else if (phones==przedo) mst*=mp[mode];
			if (!phones[1] || phones[1]=='Q' || phones[1]==' ') {
				dur+=50;
				if (*phones=='i') {
					fprintf(f,"j 30\n");
					//fprintf(stderr,"j 50\n");
				}
			}
			fprintf(f,"%s %d %d %d %d %d\n",mbrol[i].sampa,dur,10,mst,90,mst);
			//fprintf(stderr,"%s %d %d %d %d %d\n",mbrol[i].sampa,dur,10,mst,90,mst);
			phones++;
			stres=0;
			continue;
		}
		stres=0;
		qua=0;
		dur=mbrol[i].dur;
		ldur+=dur;
		switch (*phones) {
			case 'G':
				if (strchr("aeiouy",phones[1])) dur=50;
				break;
			case 'p':
				if (strchr("wnmlvfc",phones[1])) dur=80;
				break;
			case 'v':
				if (strchr("rlw",phones[1])) dur=80;
				else if (strchr("aoiueI",phones[1])) dur=30;
				break;
			case 't':
				if (strchr("pk",phones[1])) {
					dur=100;
					qua=1;
				}
				break;
			}
		
		//fprintf(stderr,"%s %d\n",mbrol[i].sampa,dur);
		fprintf(f,"%s %d\n",mbrol[i].sampa,dur);
		if (qua) {
			//fprintf(stderr,"_ 20\n");
			fprintf(f,"_ 20\n");
		}
		if (mientki(*phones) && (phones[1]=='#' || phones[1]=='=')) phones++;
		phones++;
	}
	if (mst) fprintf(f,"_ 20 0 %d\n",mst);
	fprintf(f,"; END PARASOL TRANSLATOR\n");
	fclose(f);
}

void say_mbrola(void)
{
	FILE *f;int i;
	char cmdline[256];short buff[11*512];
	sprintf(cmdline,"%s %s %s -",MBROLA_BIN,MBROLA_DB,UMBRELLA_PHO);
	f=popen(cmdline,"r");
	if (!f) {
		remove(UMBRELLA_PHO);
		return;
	}
	//printf("esd %d lin %d\n",esd_fd,linear_fd);
	for(;;) {
		i=fread(buff,2,11*512,f);
		//printf("Read %d\n",i);
		if (i<=0) break;
		if (esd_fd>=0) write_esd(i,buff);
		aufile_write(i,buff);
	}
	pclose(f);
	remove(UMBRELLA_PHO);
}
